# -*- coding: utf-8 -*-
"""
Created on Thu Oct  5 13:22:17 2017

@author: belza
This code was based on public code of the  laboratories of Digital Signal Procesing course of Berkeley University
and on some code of gr-adsb project. 
"""

# Import functions and libraries
from __future__ import division
import numpy as np, matplotlib.pyplot as plt
from rtlsdr import RtlSdr
import threading,time 
import queue as Queue
import os
import tty
import sys
import termios
import select,json
import avion as av

MAX_VUELOS = 50
my_coords = [0,0]
cantidad_aviones = 0
colors = 0
directorio = "./vuelos/"
Lecturas = 0
Salvar = False
def bit2byte( bits ):
    msg = np.zeros( int(MODES_LONG_MSG_BYTES), dtype='int' )

    # Pack bits into bytes */
    for i in np.r_[:MODES_LONG_MSG_BITS:8]:
        for j in np.r_[:8]:
            msg[ i // 8] = msg[ i // 8] + (int(bits[i+j]) << (7-j))
    return msg



        
MODES_LONG_MSG_BITS = 112
MODES_SHORT_MSG_BITS = 56
MODES_LONG_MSG_BYTES  = (112/8)
MODES_SHORT_MSG_BYTES = (56/8)


modes_checksum_table = [
0x3935ea, 0x1c9af5, 0xf1b77e, 0x78dbbf, 0xc397db, 0x9e31e9, 0xb0e2f0, 0x587178,
0x2c38bc, 0x161c5e, 0x0b0e2f, 0xfa7d13, 0x82c48d, 0xbe9842, 0x5f4c21, 0xd05c14,
0x682e0a, 0x341705, 0xe5f186, 0x72f8c3, 0xc68665, 0x9cb936, 0x4e5c9b, 0xd8d449,
0x939020, 0x49c810, 0x24e408, 0x127204, 0x093902, 0x049c81, 0xfdb444, 0x7eda22,
0x3f6d11, 0xe04c8c, 0x702646, 0x381323, 0xe3f395, 0x8e03ce, 0x4701e7, 0xdc7af7,
0x91c77f, 0xb719bb, 0xa476d9, 0xadc168, 0x56e0b4, 0x2b705a, 0x15b82d, 0xf52612,
0x7a9309, 0xc2b380, 0x6159c0, 0x30ace0, 0x185670, 0x0c2b38, 0x06159c, 0x030ace,
0x018567, 0xff38b7, 0x80665f, 0xbfc92b, 0xa01e91, 0xaff54c, 0x57faa6, 0x2bfd53,
0xea04ad, 0x8af852, 0x457c29, 0xdd4410, 0x6ea208, 0x375104, 0x1ba882, 0x0dd441,
0xf91024, 0x7c8812, 0x3e4409, 0xe0d800, 0x706c00, 0x383600, 0x1c1b00, 0x0e0d80,
0x0706c0, 0x038360, 0x01c1b0, 0x00e0d8, 0x00706c, 0x003836, 0x001c1b, 0xfff409,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000,
0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000, 0x000000
]

        
        
def modesChecksum(msg, bits):
    crc = 0;

    if (bits == 112):
        offset = 0
    else:
        offset = 112 - 56
        
    for j in np.r_[:bits]:

        byte = j//8;
        bit = j%8;
        bitmask = 1 << (7 - bit);

        # If bit is set, xor with corresponding table entry.
        if (msg[byte] & bitmask):
            crc ^= modes_checksum_table[j+offset];
    
    return crc; # 24 bit checksum. 


def modesMessageLenByType( type ):
    if ( type == 16 or type == 17 or type == 19 or type == 20 or type == 21):
        return MODES_LONG_MSG_BITS
    else:
        return MODES_SHORT_MSG_BITS
    
def fixSingleBitErrors( msg, bits ):
    for j in np.r_[:8]:
        byte = j // 8
        bitmask = 1 << (7 - (j%8))
        
        aux = msg[:int(bits/8)]
        
        crc1 = (aux[int(bits/8)-3] << 16) |(aux[int(bits/8)-2] << 8) |aux[int(bits/8)-1];
        crc2 = modesChecksum(aux,bits)
        
        crcok = (crc1 == crc2)
        if ( crcok ):
            print("fixed")
            for i in np.r_[:bits//8]:
                msg[i] = aux[i]
                
        return crcok
    
def NL( rlat ):
    # A.1.7.2.d (page 9)
    NZ = 15
    return np.floor( 2 * np.pi / 
                    (np.arccos( 1 - (1 - np.cos( np.pi / (2 * NZ )) ) 
                               / np.cos( np.pi / 180 * abs(rlat) ) ** 2 )))


def cprN( lat,  isodd):
    nl = NL(lat) - isodd;
    if (nl < 1):
        nl = 1;
    return nl;

def Dlon( lat,  isodd):
    return 360.0 / cprN(lat, isodd)

        
def cprmod( a, b ):
    res = a % b;
    if (res < 0):
        res = res + b;
    return res;


def decodeCPR( plane ):
        plane.cantidad_posiciones = plane.cantidad_posiciones + 1
        AirDlat0 = 360.0 / 60
        AirDlat1 = 360.0 / 59
            
        lat0 = plane.lat0
        lat1 = plane.lat1
        lon0 = plane.lon0
        lon1 = plane.lon1
            
        j = np.floor(((59*lat0 - 60*lat1) / 131072) + 0.5)
            
        rlat0 = AirDlat0 * (cprmod(j,60) + lat0 / 131072)
        rlat1 = AirDlat1 * (cprmod(j,59) + lat1 / 131072)
            
        if (rlat0 >= 270):
            rlat0 = rlat0 - 360
                
        if (rlat1 >= 270):
            rlat1 = rlat1 - 360
                
        if (NL(rlat0) != NL(rlat1)):
            return;
            
        if (plane.time0 > plane.time1) :

            # Use even packet.
            ni = cprN(rlat0,0);
            m = np.floor((((lon0 * (NL(rlat0)-1)) -
                        (lon1 * NL(rlat0))) / 131072) + 0.5);
            lon = Dlon(rlat0,0) * (cprmod(m,ni)+lon0/131072);
            lat = rlat0;
        else:
            # Use odd packet
            ni = cprN(rlat1,1);
            m = np.floor((((lon0 * (NL(rlat1)-1)) - 
                        (lon1 * NL(rlat1))) / 131072) + 0.5);
            lon = Dlon(rlat1,1) * (cprmod(m,ni)+lon1/131072);
            lat = rlat1;
        if ( lon > 180 ):
            lon = lon - 360;     
        plane.addposition( (lat, lon) )
        
def calcular_altura(plane, altura):
    q = altura & 0x0010
    print( "--------------q-----------", q)
    if q == 16:
        escala = 25
    else:
        escala = 100
    tmp1 = (altura & 0x1FE0) >> 1
    altitud_pies = ((altura & 0x0F) | tmp1 ) * escala - 1000
    plane.addaltura(altitud_pies * 0.3048)

def decodeModesMessage( msg, plane_list ):
    global cantidad_aviones,colors,directorio    
    ais_charset = np.array( list("?ABCDEFGHIJKLMNOPQRSTUVWXYZ????? ???????????????0123456789??????"))
    #print(msg)
    #  Get the message type ASAP as other operations depend on this
    msgtype = msg[0] >> 3
    msgbits = modesMessageLenByType(msgtype)
    
    
    # Get checksum.  CRC is always the last three bytes.
    crc = (msg[(msgbits//8)-3] << 16) |  (msg[(msgbits//8)-2] << 8) | msg[(msgbits//8)-1];
    crc2 = modesChecksum(msg,msgbits)
    crcok = (crc == crc2)

    # Correct 1-bit error
    if (not crcok):
        crcok = fixSingleBitErrors( msg, msgbits )
    
        
    # ICAO address ( airplane address )
    aa1 = msg[1]
    aa2 = msg[2]
    aa3 = msg[3]
    
    
    # Get DF 17 (ADSB) extended squitter types
    metype = msg[4] >> 3 # extended squitter message type
    mesub = msg[4] & 7
    
    if(crcok):
        print("crc: ",crcok," type: ",msgtype)
        

    # Decode extended squitter, ignore all other messages
    if ( msgtype == 17 and crcok ):
    #if(crcok):    
        addr = (aa1 << 16 ) | (aa2 << 8) | aa3
        
        # Add plane address to plane_list
        if ( addr in plane_list ):
            plane = plane_list[addr]
            plane.cantidad_vistas = plane.cantidad_vistas +1
        else:
            cantidad_aviones = cantidad_aviones +1
            plane = av.avion(addr,cantidad_aviones,colors,directorio)
            plane_list[addr] = plane
            plane.cantidad_vistas = 1
            if ( len(plane_list) == 1):
                print("Found %d plane" % len(plane_list))
            else:
                print("Found %d planes" % len(plane_list))

        if ( metype >=1 and metype <= 4 ):
            aircraft_type = metype - 1
            flight_index = np.array( [ msg[5] >> 2,
                            ((msg[5]&3)<<4)|(msg[6]>>4),
                            ((msg[6]&15)<<2)|(msg[7]>>6),
                            msg[7]&63,
                            msg[8]>>2,
                            ((msg[8]&3)<<4)|(msg[9]>>4),
                            ((msg[9]&15)<<2)|(msg[10]>>6),
                            msg[10]&63] )
            
            flightnum = ais_charset[ flight_index ]
            
            plane.addplanetype( aircraft_type )
            plane.addflightnum( "".join( flightnum ) )

        elif ( metype >= 9 and metype <= 18 ):
            
            # latitude and longitude are in CPR format
            # here we implement the global decoding described in section 5.3.1:
            # http://adsb.tc.faa.gov/WG3_Meetings/Meeting29/1090-WP29-07-Draft_CPR101_Appendix.pdf
            # see also:
            # https://sites.google.com/site/adsbreceiver/
            # http://www.lll.lu/~edward/edward/adsb/DecodingADSBposition.html
            # http://aviation.stackexchange.com/questions/3707/ads-b-compact-position-report-nl-function
            
            
            isodd = msg[6] & (1<<2);
            lat_enc = ((msg[6] & 3) << 15) | (msg[7] << 7) | (msg[8] >> 1); 
            lon_enc = ((msg[8] & 1) << 16) | (msg[9] << 8) | msg[10];
           
            
            if (isodd):
                plane.lat1 = lat_enc
                plane.lon1 = lon_enc
                plane.time1 = time.time()
                
                if (plane.time0 == -1):
                    return
            else:
                plane.lat0 = lat_enc
                plane.lon0 = lon_enc
                plane.time0 = time.time()
                
                if (plane.time1 == -1):
                    return
            
            if ( abs( plane.time0 - plane.time1 ) <= 10):
                decodeCPR( plane )
                altitud_enc = (msg[5] << 4) | (msg[6] >> 4) 
                calcular_altura(plane,altitud_enc)
        elif ( metype == 19 and mesub >=1 and mesub <= 4 ):
            if  ( mesub == 1 or mesub == 2):
                ew_dir = (msg[5]&4) >> 2;
                ew_velocity = ((msg[5]&3) << 8) | msg[6];
                ns_dir = (msg[7]&0x80) >> 7;
                ns_velocity = ((msg[7]&0x7f) << 3) | ((msg[8]&0xe0) >> 5);
                vert_rate_source = (msg[8]&0x10) >> 4;
                vert_rate_sign = (msg[8]&0x8) >> 3;
                vert_rate = ((msg[8]&7) << 6) | ((msg[9]&0xfc) >> 2);
                plane.addvelocidad_vert(vert_rate_sign,(vert_rate-1)*64)
                dif_bar_sign = (msg[10] & 0x40)>>6
                dif_bar = (msg[10] <<2) | (msg[11] & 0xc0)
                plane.adddif_bar(dif_bar_sign,dif_bar)
                plane.addvectvels(ew_velocity,ns_velocity,ew_dir,ns_dir)
            

def sdr_read( Qin, sdr, N_samples, stop_flag,leer_archivos ):
    global Salvar, Lecturas
    if(leer_archivos):
        print("Voy a leer Archivos raw")
        for arch in range(1,33):
                time.sleep(4)
                f = open(directorio + str(arch)+".raw",'r')
                data_chunk = np.fromfile(f)
                f.close()
                Qin.put( data_chunk.tolist() ) # append to list
    else:
        while (  not stop_flag.is_set() ):
       
                data_chunk = np.array(abs(sdr.read_samples(N_samples)))   # get samples 
                Qin.put( data_chunk.tolist() ) # append to list
                if(Salvar == True):
                        Lecturas = Lecturas +1
                        f = open(directorio + str(Lecturas)+".raw",'w')
                        data_chunk.tofile(f)
                        f.close()
        sdr.close()


def signal_process( Qin,functions, stop_flag,Qpos  ):
    
    detectPreamble = functions[0]
    data2bit = functions[1]
    plane_list = {};
    while(  not stop_flag.is_set() ):
        chunk = Qin.get();
        idx_preamble = detectPreamble(chunk)
        for n in idx_preamble:
            bits = data2bit(chunk[n:(n+16+MODES_LONG_MSG_BITS*2)])
            if len(bits) == MODES_LONG_MSG_BITS :
                msg = bit2byte( bits )
                decodeModesMessage( msg, plane_list )
        flightnum = []
        print(plane_list)                
        for addr in plane_list:
            plane = plane_list[addr]
            flightnum.append( plane.flightnum )   
            print(plane.flightnum)
            print(plane.cantidad_vistas)
            print(" cantidad posiciones : ",plane.cantidad_posiciones, " cantidad heading ",len(plane.headings))
            pos = plane.nuevas_posiciones()
            if len(pos)>0:
                Qpos.put(pos)
                plane.salvaryborrar_datos()


def process_run(Qpos,grados,stop_flag):
    global my_coords, Salvar
    orig_settings = termios.tcgetattr(sys.stdin)
    tty.setraw(sys.stdin)
    x = 0
    termios.tcsetattr(sys.stdin, termios.TCSADRAIN, orig_settings)    
    while True:
         min_marker_size = 10
         try:
             positions = Qpos.get(block=True,timeout=0.1)
             if select.select([sys.stdin], [], [], 0)[0]:
                 x=sys.stdin.read(1)[0]
                 print("You pressed 1 ", x)
                 if x == '\x1b':
                     print("sali sin exception")
                     break
                 if x == 'S':
                     print("salvar")
                     Salvar = True
                 if x == 'D':
                     print("dejar de salvar")
                     Salvar = False
             print("posiciones  ",positions)
         except Queue.Empty:
             if select.select([sys.stdin], [], [], 0)[0]:
                 x=sys.stdin.read(1)[0]
                 print("You pressed 2 ", x)
                 if x == '\x1b':
                     print("sali con exception")
                     break
                 if x == 'S':
                     print("salvar")
                     Salvar = True
                 if x == 'D':
                     print("dejar de salvar")
                     Salvar = False
                 if x == 'E':
                     print("limpiar mapa") 
             continue
         except Exception as e:
            print(type(e))     # the exception instance
            print(e.args)      # arguments stored in .args
            if select.select([sys.stdin], [], [], 0)[0]:
                x=sys.stdin.read(1)[0]
                print("You pressed 2 ", x)
                if x == '\x1b':
                    print("sali con exception")
                    break
                if x == 'S':
                    print("salvar")
                    Salvar = True
                if x == 'D':
                    print("dejar de salvar") 
                    Salvar = False
                if x == 'E':
                    print("limpiar mapa") 
            continue
    stop_flag.set()
        
                
def show_flights( fs, center_freq, gain, N_samples, pos_ref, functions,leer_archivos ):
    global colors 
    colors = plt.cm.rainbow(np.linspace(0, 3, MAX_VUELOS))
    global my_coords 
    my_coords = pos_ref
    time.sleep(1)
    Qin = Queue.Queue()
    Qpos = Queue.Queue()
    grados =1
    sdr = RtlSdr()
    sdr.sample_rate = fs    # sampling rate
    sdr.center_freq = center_freq   # 1090MhZ center frequency
    sdr.gain = gain
    aux = 0
    stop_flag = threading.Event()
    print("Voy a correr thread sdr")
    t_sdr_read = threading.Thread(target = sdr_read,   args = (Qin, sdr, N_samples, stop_flag,leer_archivos  ))
    t_signal_process = threading.Thread(target = signal_process, args = ( Qin, functions, stop_flag,Qpos))
    t_sdr_read.start()
    t_signal_process.start()
    process_run(Qpos,grados,stop_flag)
    t_sdr_read.join()
    t_signal_process.join()
    print("end")
    return stop_flag


        
